//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

extern string S1="Main Sets:";
extern int Slippage=5;
extern int MyLevel=300;
extern int InterVal=30;
extern int LineLimit=10;
extern int Requots=1;
extern int TestLimit=3000;
extern int TestSpread=15;
extern int LotsDigits=2;
extern int DepoDigits=2;
extern bool ConsoleLines=true;
extern bool ConsolePT=true;
extern bool MarketExec=true;

extern double PresStepLots=0.1;
extern int PresStepRisk=10;
extern int PresStepSL=10;
extern int PresStepTP=10;
extern int PresStepTrall=10;
extern int PresStepStep=10;
extern int PresStepPTrall=10;
extern int PresStepPStep=10;
extern int PresStepXP=10;

extern bool UnSelectCom=true;
extern bool UnSelectPres=false;

//  
double Lots=0.01;
int Risk=0;
int StopLoss=0;
int TakeProfit=0;
int TrallingStop=0;
int TrallingStep=0;
int PendTrallingStop=0;
int PendTrallingStep=0;
int XProfit=0;
int LevelShift=20;
bool Reverse=false;
bool Reverse2=false;
bool UseSound=true;
bool UseBlock=false;
bool UseConfirm=false;
bool UseMasks=false;
bool QuickRun=true;



int TickS1_Buy=0;
int TickS1_Sell=0;
int TickS2_Buy=0;
int TickS2_Sell=0;
int TickS3_Buy=0;
int TickS3_Sell=0;
int TickS4_Buy=0;
int TickS4_Sell=0;
int TickS5_Buy=0;
int TickS5_Sell=0;
int Requotes;
int BarTime=0;
string   Com_Name[500];
string   Com_Title[500];
string   Com_Font[500];
int      Com_FontSize[500];
color    Com_Color[500];
int      Com_Corner[500];
int      Com_PosX[500];
int      Com_PosY[500];
int      Com_Window[500];
int      Com_Visible[500];
string   Com_BackTitle[500];
string   Com_BackFont[500];
int      Com_BackFontSize[500];
color    Com_BackColor[500];
int      Com_BackPosX[500];
int      Com_BackPosY[500];

string   Pres_Name[500];
string   Pres_Title[500];
string   Pres_Font[500];
int      Pres_FontSize[500];
color    Pres_Color[500];
int      Pres_Corner[500];
int      Pres_PosX[500];
int      Pres_PosY[500];
int      Pres_Window[500];
int      Pres_Visible[500];

string   Stat_Name[500];
string   Stat_Title[500];
string   Stat_Font[500];
int      Stat_FontSize[500];
color    Stat_Color[500];
int      Stat_Corner[500];
int      Stat_PosX[500];
int      Stat_PosY[500];
int      Stat_Window[500];
int      Stat_Visible[500];



int ComLastID=0;
int PresLastID=0;
int StatLastID=0;
int MaskLastID=0;

int Reqs=0;
int STAT_L;

int
   CM_BUY,
   CM_SELL,
   CM_CLOSE,
   CM_PROFITS,
   CM_LOSES,
   CM_BUYSTOP,
   CM_SELLSTOP,
   CM_BUYLIMIT,
   CM_SELLLIMIT,
   CM_SMASH,
   CM_TOTALSMASH,
   CM_DELETE,
   CM_ST_UP,
   CM_ST_DN,
   CM_EX_UP,
   CM_EX_DN,
   CM_ST_DL,
   CM_EX_DL,
   CM_RESET,
   CM_SETS,
   CM_SOUND,
   CM_MASKS,
   CM_REV1,
   CM_REV2,
   CM_CONFIRM,
   CM_BLOCK,
   CM_RUN,
   
   ST_TITLE,
   ST_PRT,
   ST_PRV,
   ST_BLV,
   ST_EQV,
   ST_FMV,
   ST_SSV,
   ST_STAT,
   ST_OK,
   ST_DLOTS,
   ST_DRISK,
   ST_DTP,
   ST_DSL,
   ST_DXPROFIT,
   ST_DTRALL,
   ST_DSTEP,
   ST_DPTRALL,
   ST_DPSTEP,
   ST_DOK,
   ST_TIME,
   ST_REQS,
   ST_INF1,
   ST_INF2,
   ST_INF3,
   
   PR_LOTS,
   PR_RISK,
   PR_SL,
   PR_TP,
   PR_XP,
   PR_TRALL,
   PR_STEP,
   PR_PTRALL,
   PR_PSTEP
   ;
int TimeStart=0;
int Fncs=0;
#include <SF11_Skin.mqh>
#include <SF11_Trade.mqh>
#include <SF11_Com.mqh>
#include <SF11_Events.mqh>
#include <SF11_Tools.mqh>
#include <SF11_Strategy_Tpl.mqh>
#include <SF11_Objects.mqh>
#include <SF11_Mask.mqh>
#include <SF11_Bar.mqh>

void init(){
   if(UseSound==true) PlaySound(SND_Intro);
   if(TimeStart==0) TimeStart=TimeCurrent();
   Requotes=Requots;
   ReadPresets();
   SkinStandart();
   RefStatics();
   int ResID;
   MaskOn();
   StrInit();
   
   while(true){
      exec();
      if(QuickRun==false) return;
      }
   }

void deinit()
  {
   EraseCommands();
   ErasePresets();
   EraseStatics();
   KillMasks();
   StrReturn();
   return;
  }

void start(){
   while(true){
      exec();
      if(QuickRun==false) return;
      }
   }
void exec(){
   int ResID;
   Fncs=0;
   if(BarTime!=Time[0]){
      BarTime=Time[0];
      once();
      }
   if(IsTesting()==true){
      QuickRun=false;
      UseConfirm=False;
      }
   if(TrallingStop>0) DoTrallingStop();
   if(PendTrallingStop>0) DoPendTrall();
   if(Reverse2==true) Reverse2Check();
   LiveStatics();
   RefStatics();
   UsePresets();
   if(UseMasks==true){
      ReviseMasks();
      NurseMasks();
      }else{
      KillMasks();
      }
   if(UseBlock==true) CheckLines();
   TickEvent();
   StrUse();
   int Fgd=300;
   if(QuickRun==false) Fgd=1;
   for(int z=0;z<=Fgd;z++){
      ResID=UseCommands();
      if(ResID>0){
         Comment(" ");
         z=9999999;
         }
      //if(IsTesting()==false) Sleep();
      }
   Comment(" ");
   }
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+

