//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

#define MASK_OP 0
#define MASK_SL 1
#define MASK_TP 2



void PlaceMask(string Inn,int Mode,double Price){
   Fncs++;
   if(Mode==0) ObjectSet("__Mask_Open_"+Inn,OBJPROP_PRICE1,Price);
   if(Mode==1) ObjectSet("__Mask_SL_"+Inn,OBJPROP_PRICE1,Price);
   if(Mode==2) ObjectSet("__Mask_TP_"+Inn,OBJPROP_PRICE1,Price);
   return;
   }
double MaskGet(string Inn,int Mode){
   Fncs++;
   if(Mode==0) return(ObjectGet("__Mask_Open_"+Inn,OBJPROP_PRICE1));
   if(Mode==1) return(ObjectGet("__Mask_SL_"+Inn,OBJPROP_PRICE1));
   if(Mode==2) return(ObjectGet("__Mask_TP_"+Inn,OBJPROP_PRICE1));
   return(-1);
   }

void ReviseMasks(){
   Fncs++;
   int i,j,k,l;
   double Proc,SL,TP,OP;
   string Inn;
   for(i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()==Symbol()){
         Inn=DoubleToStr(OrderTicket(),0);
         if(OrderType()==OP_SELL || OrderType()==OP_BUY){
            OP=NormalizeDouble(MaskGet(Inn,0),Digits);
            SL=NormalizeDouble(MaskGet(Inn,1),Digits);
            TP=NormalizeDouble(MaskGet(Inn,2),Digits);
            if(OrderOpenTime()<TimeCurrent()-InterVal && ObjectFind("__Mask_Open_"+Inn)==-1){
               CloseNow(OrderTicket());
               OP=0;
               }
            if(OrderOpenTime()>=TimeCurrent()-InterVal){
               VisibleMask(OrderTicket());
               }
            //Print(DoubleToStr(OP,Digits)," ",DoubleToStr(OrderOpenPrice(),Digits));
            if(OP!=NormalizeDouble(OrderOpenPrice(),Digits)){
               //PlaySound("ok.wav");
               if((OP>Ask && OrderType()==OP_BUY)||(OP<Bid && OrderType()==OP_SELL)) TP=OP;
               if((OP<Bid && OrderType()==OP_BUY)||(OP>Ask && OrderType()==OP_SELL)) SL=OP;
               }
            
            if(SL!=NormalizeDouble(OrderStopLoss(),Digits)){
               if(OrderType()==OP_BUY && SL>Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)-LevelShift)*Point && SL>0) SL=Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               if(OrderType()==OP_SELL && SL<Ask+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point && SL>0) SL=Ask+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               }
            if(TP!=OrderTakeProfit()){
               if(OrderType()==OP_BUY && TP<Bid+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point && TP>0) TP=Bid+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               if(OrderType()==OP_SELL && TP>Ask-(MarketInfo(Symbol(),MODE_STOPLEVEL)-LevelShift)*Point && TP>0) TP=Ask-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               }
            //*/
            OrderSelect(OrderTicket(),SELECT_BY_TICKET);
            if((NormalizeDouble(OrderStopLoss(),Digits)!=NormalizeDouble(SL,Digits) || NormalizeDouble(OrderTakeProfit(),Digits)!=NormalizeDouble(TP,Digits))&& OP>0){
               //Print(DoubleToStr(OrderStopLoss(),Digits)," ",DoubleToStr(SL,Digits));
               //Print(DoubleToStr(OrderTakeProfit(),Digits)," ",DoubleToStr(TP,Digits));
               //if(OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,0)==true)
               Reqs++;
               ReqOn("  ");
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),0);
               if(UseSound==true) PlaySound(SND_Modify);
               ReqOn("  "," !","",1000);
               }else Comment("");
            OrderSelect(OrderTicket(),SELECT_BY_TICKET);
            VisibleMask(OrderTicket());
            PlaceMask(Inn,0,OrderOpenPrice());
            PlaceMask(Inn,1,OrderStopLoss());
            PlaceMask(Inn,2,OrderTakeProfit());
            }
         if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP || OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT){
            OP=MaskGet(Inn,0);
            SL=MaskGet(Inn,1);
            TP=MaskGet(Inn,2);
            if(OrderOpenTime()<TimeCurrent()-InterVal && ObjectFind("__Mask_Open_"+Inn)==-1){
               Reqs++;
               ReqOn("  ");
               OrderDelete(OrderTicket());
               if(UseSound==true) PlaySound(SND_Delete);
               ReqOn("  "," !","",1000);
               OP=0;
               }
            if(OrderOpenTime()>=TimeCurrent()-InterVal){
               VisibleMask(OrderTicket());
               }
            if(OP!=OrderOpenPrice()&& OP>0){
               if((OrderType()==OP_SELLLIMIT || OrderType()==OP_BUYSTOP) && OP<Ask+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point) OP=Ask+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               if((OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLSTOP) && OP>Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point) OP=Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               Proc=OP-OrderOpenPrice();
               if(SL>0) SL+=Proc;
               if(TP>0) TP+=Proc;
               }
            if(SL!=OrderStopLoss()){
               if((OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) && SL<OP+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point && SL>0) SL=OP+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               if((OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) && SL>OP-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point && SL>0) SL=OP-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               }
            if(TP!=OrderTakeProfit()){
               if((OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) && TP>OP-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point && TP>0) TP=OP-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               if((OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) && TP<OP+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point && TP>0) TP=OP+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
               }
            if((OP!=OrderOpenPrice()|| SL!=OrderStopLoss()|| TP!=OrderTakeProfit())&& OP>0){
               Reqs++;
               ReqOn("  ");
               OrderModify(OrderTicket(),NormalizeDouble(OP,Digits),NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),0);
               if(UseSound==true) PlaySound(SND_Modify);
               ReqOn("  "," !","",1000);
               }
            VisibleMask(OrderTicket());
            PlaceMask(Inn,0,OrderOpenPrice());
            PlaceMask(Inn,1,OrderStopLoss());
            PlaceMask(Inn,2,OrderTakeProfit());
            }
         }
      }
   }


void MaskOn(){
   Fncs++;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      VisibleMask(OrderTicket());
      }
   }

void NurseMasks(){
   Fncs++;
   string Name3;
   for(int i=ObjectsTotal()-1;i>=0;i--){
      string Name=ObjectName(i);
      string Name1=StringSubstr(Name,0,7);
      if(Name1=="__Mask_"){
         string Name2=StringSubstr(Name,7,2);
         if(Name2=="Op") Name3=StringSubstr(Name,12);
         else Name3=StringSubstr(Name,10);
         int Tic=StrToInteger(Name3);
         if(OrderSelect(Tic,SELECT_BY_TICKET)==false){
            if(ObjectFind(Name)!=-1) ObjectDelete(Name);
            }
         if(OrderCloseTime()>0){
            if(ObjectFind(Name)!=-1) ObjectDelete(Name);
            }
         }
      }
   }
 
void KillMasks(){
   Fncs++;
   string Name3;
   for(int i=ObjectsTotal()-1;i>=0;i--){
      string Name=ObjectName(i);
      string Name1=StringSubstr(Name,0,7);
      if(Name1=="__Mask_"){
         if(ObjectFind(Name)!=-1) ObjectDelete(Name);
         }
      }
   }
void VisibleMask(int Ticket){
   Fncs++;
   OrderSelect(Ticket,SELECT_BY_TICKET);
   if(OrderSymbol()==Symbol()){
      if(ObjectFind("__Mask_Open_"+DoubleToStr(OrderTicket(),0))==-1){
         ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
         ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
         ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
         ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
         ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
         }
      if(ObjectFind("__Mask_SL_"+DoubleToStr(OrderTicket(),0))==-1 && OrderStopLoss()>0){
         ObjectCreate("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderStopLoss());
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskSL);
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
         }
      if(ObjectFind("__Mask_TP_"+DoubleToStr(OrderTicket(),0))==-1 && OrderTakeProfit()>0){
         ObjectCreate("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderTakeProfit());
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskTP);
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
         }
      if(OrderType()==OP_SELL || OrderType()==OP_BUY) ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
      if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP) ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskStop);
      if(OrderType()==OP_SELLLIMIT || OrderType()==OP_BUYLIMIT) ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskLimit);
      }
   }
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+



