//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

int OpSell(string Symb="",double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   Fncs++;
   if(Reverse==true) CloseBuys();
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   double SL=0;
   double TP=0;
   int Tick=0;
   RefreshRates();
   if(StLs>0 && StLs<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) StLs=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   if(TkPr>0 && TkPr<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) TkPr=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   if(StLs>0) SL=Bid+StLs*Point;
   if(TkPr>0) TP=Bid-TkPr*Point;
   ReqOn("  ");
   if(MarketExec==true){
      Tick=OrderSend(Symb,OP_SELL,Vol,Bid,Slippage,0,0);
      OrderSelect(Tick,SELECT_BY_TICKET);
      RefreshRates();
      if(StLs>0) SL=Bid+StLs*Point;
      if(TkPr>0) TP=Bid-TkPr*Point;
      OrderModify(Tick,OrderOpenPrice(),SL,TP,0);
      if(UseSound==true) PlaySound(SND_Order);
      MaskOn();
      return(Tick);
      }
   for(int i=1;i<=Requots;i++){
      Reqs++;
      Tick=OrderSend(Symb,OP_SELL,Vol,Bid,Slippage,SL,TP);
      if(Tick>0){
         if(UseSound==true) PlaySound(SND_Order);
         MaskOn();
         ReqOn("  "," SELL!","",1000);
         return(Tick);
         }
         else{
         if(GetLastError()!=135){
            Error(GetLastError());
            return(0);
            }
         }
      ReqOn("  ","!   "+DoubleToStr(i+1,0));
      }
   if(UseSound==true) PlaySound(SND_Order);
   MaskOn();
   return(Tick);
   }

int OpBuy(string Symb="",double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   Fncs++;
   if(Reverse==true) CloseSells();
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   double SL=0;
   double TP=0;
   int Tick=0;
   if(StLs>0 && StLs<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) StLs=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   if(TkPr>0 && TkPr<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) TkPr=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   RefreshRates();
   if(StLs>0) SL=Ask-StLs*Point;
   if(TkPr>0) TP=Ask+TkPr*Point;
   //ReqOn();
   ReqOn("  ");
   if(MarketExec==true){
      Tick=OrderSend(Symb,OP_BUY,Vol,Bid,Slippage,0,0);
      OrderSelect(Tick,SELECT_BY_TICKET);
      RefreshRates();
      if(StLs>0) SL=Ask-StLs*Point;
      if(TkPr>0) TP=Ask+TkPr*Point;
      OrderModify(Tick,OrderOpenPrice(),NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),0);
      if(UseSound==true) PlaySound(SND_Order);
      MaskOn();
      return(Tick);
      }
   for(int i=1;i<=Requots;i++){
      Reqs++;
      
      Tick=OrderSend(Symb,OP_BUY,Vol,Ask,Slippage,SL,TP);
      if(Tick>0){
         if(UseSound==true) PlaySound(SND_Order);
         MaskOn();
         ReqOn("  "," BUY!","",1000);
         return(Tick);
         }
         else{
         if(GetLastError()!=135){
            Error(GetLastError());
            return(0);
            }
         }
      ReqOn("  ","!   "+DoubleToStr(i+1,0));
      }
   if(UseSound==true) PlaySound(SND_Order);
   MaskOn();
   return(Tick);
   }
int BuyStop(string Symb,double Price,double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   Fncs++;
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   if(Snd=="") Snd="ok.wav";
   double SL=0;
   double TP=0;
   int Tick=0;
   if(StLs>0 && StLs<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) StLs=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   if(TkPr>0 && TkPr<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) TkPr=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   RefreshRates();
   if(Price<Ask+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point) Price=Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
   if(StLs>0) SL=Price-StLs*Point;
   if(TkPr>0) TP=Price+TkPr*Point;
   Reqs++;
   ReqOn("  ");
   Tick=OrderSend(Symb,OP_BUYSTOP,Vol,NormalizeDouble(Price,Digits),Slippage,SL,TP);
   if(Tick>0){
      if(UseSound==true) PlaySound(SND_Pend);
      ReqOn("  "," BUY STOP!","",1000);
      }
   MaskOn();
   return(Tick);
   }
int BuyLimit(string Symb,double Price,double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   Fncs++;
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   if(Snd=="") Snd="ok.wav";
   double SL=0;
   double TP=0;
   int Tick=0;
   if(StLs>0 && StLs<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) StLs=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   if(TkPr>0 && TkPr<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) TkPr=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   RefreshRates();
   if(Price>Ask-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point) Price=Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
   if(StLs>0) SL=Price-StLs*Point;
   if(TkPr>0) TP=Price+TkPr*Point;
   Reqs++;
   ReqOn("  ");
   Tick=OrderSend(Symb,OP_BUYLIMIT,Vol,NormalizeDouble(Price,Digits),Slippage,SL,TP);
   if(Tick>0){
      if(UseSound==true) PlaySound(SND_Pend);
      ReqOn("  "," BUY LIMIT!","",1000);
      }
   MaskOn();
   return(Tick);
   }
int SellStop(string Symb,double Price,double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   Fncs++;
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   if(Snd=="") Snd="ok.wav";
   double SL=0;
   double TP=0;
   int Tick=0;
   if(StLs>0 && StLs<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) StLs=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   if(TkPr>0 && TkPr<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) TkPr=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   RefreshRates();
   if(Price>Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point) Price=Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
   if(StLs>0) SL=Price+StLs*Point;
   if(TkPr>0) TP=Price-TkPr*Point;
   Reqs++;
   ReqOn("  ");
   Tick=OrderSend(Symb,OP_SELLSTOP,Vol,NormalizeDouble(Price,Digits),Slippage,SL,TP);
   if(Tick>0){
      if(UseSound==true) PlaySound(SND_Pend);
      ReqOn("  "," SELL STOP!","",1000);
      }
   MaskOn();
   return(Tick);
   }
int SellLimit(string Symb,double Price,double Vol=NULL,int StLs=-1,int TkPr=-1,string Snd=""){
   Fncs++;
   if(Symb=="") Symb=Symbol();
   if(StLs==-1) StLs=StopLoss;
   if(TkPr==-1) TkPr=TakeProfit;
   if(Vol==NULL) Vol=Lots;
   if(Snd=="") Snd="ok.wav";
   double SL=0;
   double TP=0;
   int Tick=0;
   if(StLs>0 && StLs<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) StLs=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   if(TkPr>0 && TkPr<MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift) TkPr=MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift;
   RefreshRates();
   if(Price<Bid+(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point) Price=Bid-(MarketInfo(Symbol(),MODE_STOPLEVEL)+LevelShift)*Point;
   if(StLs>0) SL=Price+StLs*Point;
   if(TkPr>0) TP=Price-TkPr*Point;
   Reqs++;
   ReqOn("  ");
   Tick=OrderSend(Symb,OP_SELLLIMIT,Vol,NormalizeDouble(Price,Digits),Slippage,SL,TP);
   if(Tick>0){
      if(UseSound==true) PlaySound(SND_Pend);
      ReqOn("  "," SELL LIMIT!","",1000);
      }
   MaskOn();
   return(Tick);
   }
void DeleteSellStops(){
   Fncs++;
   ReqOn("  ");
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol()){
         Reqs++;
         OrderDelete(OrderTicket());
         ReqOn("  "," !");
         if(UseSound==true) PlaySound(SND_Pend);
         }
      }
   return;
   }
void DeleteBuyStops(){
   Fncs++;
   ReqOn("  ");
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol()){
         Reqs++;
         OrderDelete(OrderTicket());
         ReqOn("  "," !");
         if(UseSound==true) PlaySound(SND_Pend);
         }
      }
   return;
   }
void DeleteSellLimits(){
   Fncs++;
   ReqOn("  ");
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELLLIMIT && OrderSymbol()==Symbol()){
         Reqs++;
         OrderDelete(OrderTicket());
         ReqOn("  "," !");
         if(UseSound==true) PlaySound(SND_Pend);
         }
      }
   return;
   }
void DeleteBuyLimits(){
   Fncs++;
   ReqOn("  ");
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUYLIMIT && OrderSymbol()==Symbol()){
         Reqs++;
         OrderDelete(OrderTicket());
         ReqOn("  "," !");
         if(UseSound==true) PlaySound(SND_Pend);
         }
      }
   return;
   }
void CloseSells(string Snd="ok.wav"){
   Fncs++;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         CloseNow(OrderTicket());
         }
      }
   //PlaySound(SND_Close);
   return;
   }
void CloseBuys(string Snd="ok.wav"){
   Fncs++;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         CloseNow(OrderTicket());
         }
      }
   return;
   }
void CloseProfits(){
   Fncs++;
   int j;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderProfit()>=0 && OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         CloseNow(OrderTicket());
         }
      if(OrderProfit()>=0 && OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         CloseNow(OrderTicket());
         }
      }
   }
void CloseLoses(){
   Fncs++;
   int j;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderProfit()<0 && OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         CloseNow(OrderTicket());
         }
      if(OrderProfit()<0 && OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         CloseNow(OrderTicket());
         }
      }
   }
void TotalSmash(){
   Fncs++;
   for(int i=OrdersTotal();i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELL || OrderType()==OP_BUY){
         CloseNow(OrderTicket());
         }else{
         Reqs++;
         OrderDelete(OrderTicket());
         ReqOn("  "," !");
         }
      }
   return;
   }
int CloseNow(int Ticket){
   Fncs++;
   OrderSelect(Ticket,SELECT_BY_TICKET);
   int Closer,Res;
   if(OrderType()==OP_SELL) Closer=MODE_ASK;
   else if(OrderType()==OP_BUY) Closer=MODE_BID;
   else return(-1);
   ReqOn("  ");
   for(int i=1;i<=Requotes;i++){
      Reqs++;
      Res=(OrderClose(Ticket,OrderLots(),MarketInfo(OrderSymbol(),Closer),Slippage));
      int Err=GetLastError();
      if(Res==true){
         if(UseSound==1) PlaySound(SND_Close);
         ReqOn("  "," !",300);
         return(0);
         }
      if(Err==1) return(1);
      if(Err!=135) return(Err);
      }
   return(-2);
   }
/*
 CloseNow()
 0 -  
-1 -    
-2 -    
  - .  ,   
*/
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+