//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

int UseCommands(){
   Fncs++;
   int Coff=1;
   int ResID=CommandsCheck();
   if(ResID>5000){
      /*PRESETS*/
      ResID-=5000;
      if(ResID>5000){
         Coff=-1;
         ResID-=5000;
         }
      if(ResID==PR_LOTS){
         Lots+=PresStepLots*Coff;
         if(Lots<MarketInfo(Symbol(),MODE_MINLOT)) Lots=MarketInfo(Symbol(),MODE_MINLOT);
         if(Lots>MarketInfo(Symbol(),MODE_MAXLOT)) Lots=MarketInfo(Symbol(),MODE_MAXLOT);
         Lots=NormalizeDouble(Lots,LotsDigits);
         Pres_Title[ResID]=DoubleToStr(Lots,LotsDigits);
         VisiblePreset(ResID);
         }
      if(ResID==PR_RISK){
         Risk+=PresStepRisk*Coff;
         if(Risk<0) Risk=0;
         if(Risk>100) Risk=100;
         Risk=NormalizeDouble(Risk,0);
         Pres_Title[ResID]=DoubleToStr(Risk,0);
         VisiblePreset(ResID);
         UsePresets();
         }
      if(ResID==PR_SL){
         StopLoss+=PresStepSL*Coff;
         if(StopLoss<0) StopLoss=0;
         Pres_Title[ResID]=DoubleToStr(StopLoss,0);
         VisiblePreset(ResID);
         }
      if(ResID==PR_TP){
         TakeProfit+=PresStepTP*Coff;
         if(TakeProfit<0) TakeProfit=0;
         Pres_Title[ResID]=DoubleToStr(TakeProfit,0);
         VisiblePreset(ResID);
         }
      if(ResID==PR_TRALL){
         TrallingStop+=PresStepTrall*Coff;
         if(TrallingStop<0) TrallingStop=0;
         Pres_Title[ResID]=DoubleToStr(TrallingStop,0);
         VisiblePreset(ResID);
         }
      if(ResID==PR_STEP){
         TrallingStep+=PresStepStep*Coff;
         if(TrallingStep<0) TrallingStep=0;
         Pres_Title[ResID]=DoubleToStr(TrallingStep,0);
         VisiblePreset(ResID);
         }
      if(ResID==PR_PTRALL){
         PendTrallingStop+=PresStepPTrall*Coff;
         if(PendTrallingStop<0) PendTrallingStop=0;
         Pres_Title[ResID]=DoubleToStr(PendTrallingStop,0);
         VisiblePreset(ResID);
         }
      if(ResID==PR_STEP){
         PendTrallingStep+=PresStepPStep*Coff;
         if(PendTrallingStep<0) PendTrallingStep=0;
         Pres_Title[ResID]=DoubleToStr(PendTrallingStep,0);
         VisiblePreset(ResID);
         }
      if(ResID==PR_XP){
         XProfit+=PresStepXP*Coff;
         if(XProfit<0) XProfit=0;
         Pres_Title[ResID]=DoubleToStr(XProfit,0);
         VisiblePreset(ResID);
         }
      return(ResID);
      }
   if(ResID==CM_SOUND){
      if(UseSound==true){
         UseSound=false;
         Com_Color[ResID]=CL_FlagOff;
         }else{
         UseSound=true;
         Com_Color[ResID]=CL_FlagOn;
         }
      VisibleCommand(ResID);
      }
   if(ResID==CM_BUY) if(UserConf("  BUY!!!"," ")==true) OpBuy();
   if(ResID==CM_SELL) if(UserConf("  SELL!!!"," ")==true) OpSell();
   if(ResID==CM_CLOSE) if(UserConf("   !!!"," ")==true){
      CloseSells();
      CloseBuys();
      }
   if(ResID==CM_PROFITS) if(UserConf("    !!!"," ")==true) CloseProfits();
   if(ResID==CM_LOSES) if(UserConf("    !!!"," ")==true) CloseLoses();
   if(ResID==CM_SMASH) if(UserConf("   SMASH!!!"," ")==true){
      CloseSells();
      CloseBuys();
      DeleteBuyStops();
      DeleteSellStops();
      DeleteBuyLimits();
      DeleteSellLimits();
      }
   if(ResID==CM_TOTALSMASH) if(MessageBox("   TOTAL SMASH!!!"," ",0x00000001)==1) TotalSmash();
   if(ResID==CM_BUYSTOP) if(UserConf("  BUYSTOP!!!"," ")==true) BuyStop("",Ask+MyLevel*Point);
   if(ResID==CM_SELLSTOP) if(UserConf("  SELLSTOP!!!"," ")==true) SellStop("",Bid-MyLevel*Point);
   if(ResID==CM_BUYLIMIT) if(UserConf("  BUYLIMIT!!!"," ")==true) BuyLimit("",Ask-MyLevel*Point);
   if(ResID==CM_SELLLIMIT) if(UserConf("  SELLLIMIT!!!"," ")==true) SellLimit("",Bid+MyLevel*Point);
   if(ResID==CM_DELETE) if(UserConf("    STOP!!!"," ")==true){
      DeleteBuyStops();
      DeleteSellStops();
      }
   if(ConsoleLines==true){
   RefreshRates();
   if(ResID==CM_ST_UP) NewLine(1,Ask+MyLevel*Point);
   if(ResID==CM_ST_DN) NewLine(1,Bid-MyLevel*Point);
   if(ResID==CM_EX_UP) NewLine(2,Ask+MyLevel*Point);
   if(ResID==CM_EX_DN) NewLine(2,Bid-MyLevel*Point);
   if(ResID==CM_RESET) if(UserConf("   RESET!!!"," ")==true){
      DelLine(1);
      DelLine(2);
      }
   }
   if(ResID==CM_BLOCK){
      if(UseBlock==true){
         UseBlock=false;
         Com_Color[ResID]=CL_FlagOff;
         }else{
         UseBlock=true;
         Com_Color[ResID]=CL_FlagOn;
         }
      VisibleCommand(ResID);
      }
   if(ResID==CM_MASKS){
      if(UseMasks==true){
         UseMasks=false;
         KillMasks();
         Com_Color[ResID]=CL_FlagOff;
         }else{
         MaskOn();
         UseMasks=true;
         Com_Color[ResID]=CL_FlagOn;
         }
      VisibleCommand(ResID);
      }
   if(ResID==CM_REV1){
      if(Reverse==true){
         Reverse=false;
         Com_Color[ResID]=CL_FlagOff;
         }else{
         Reverse=true;
         Com_Color[ResID]=CL_FlagOn;
         }
      VisibleCommand(ResID);
      }
   if(ResID==CM_REV2){
      if(Reverse2==true){
         Reverse2=false;
         Com_Color[ResID]=CL_FlagOff;
         }else{
         Reverse2=true;
         Com_Color[ResID]=CL_FlagOn;
         }
      VisibleCommand(ResID);
      }
   if(ResID==CM_CONFIRM){
      if(UseConfirm==true){
         UseConfirm=false;
         Com_Color[ResID]=CL_FlagOff;
         }else{
         UseConfirm=true;
         Com_Color[ResID]=CL_FlagOn;
         }
      VisibleCommand(ResID);
      }
   if(ResID==CM_RUN){
      if(QuickRun==true){
         QuickRun=false;
         Com_Color[ResID]=CL_FlagOff;
         }else{
         QuickRun=true;
         Com_Color[ResID]=CL_FlagOn;
         }
      VisibleCommand(ResID);
      }
   
   StrUseCommands(ResID);
   return(ResID);
   }
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+

