//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://evgeno.ru"

double Lots;
int StopLoss,TakeProfit,Requots,LevelShift,Slippage,Risk,XProfit;
bool UseSound,Reverse;
string
   SND_Order,
   SND_Close,
   SND_Pend,
   SND_Delete,
   SND_Line
   ;

void Params(){
   Lots=NormalizeDouble(StrToDouble(ObjectDescription("P_Lots")),2);
   if(Lots>MarketInfo(Symbol(),MODE_MAXLOT)) Lots=MarketInfo(Symbol(),MODE_MAXLOT);
   if(Lots<MarketInfo(Symbol(),MODE_MINLOT)) Lots=MarketInfo(Symbol(),MODE_MINLOT);
   
   StopLoss=StrToDouble(ObjectDescription("P_SL"));
   TakeProfit=StrToDouble(ObjectDescription("P_TP"));
   LevelShift=StrToDouble(ObjectDescription("_____LevelShift"));
   Requots=StrToDouble(ObjectDescription("_____Requotes"));
   Slippage=StrToDouble(ObjectDescription("_____Slippage"));
   
   SND_Order=ObjectDescription("_____SND_Order");
   SND_Close=ObjectDescription("_____SND_Close");
   SND_Pend=ObjectDescription("_____SND_Pend");
   SND_Delete=ObjectDescription("_____SND_Delete");
   SND_Line=ObjectDescription("_____SND_Line");
   
   if(ObjectGet("C_Sound",OBJPROP_COLOR)==ObjectGet("_____FlagOn",OBJPROP_COLOR)) UseSound=true; else UseSound=false;
   if(ObjectGet("C_Reverse",OBJPROP_COLOR)==ObjectGet("_____FlagOn",OBJPROP_COLOR)) Reverse=true; else Reverse=false;
   return;
   }
int CloseNow(int Ticket){
   OrderSelect(Ticket,SELECT_BY_TICKET);
   int Closer,Res;
   if(OrderType()==OP_SELL) Closer=MODE_ASK;
   else if(OrderType()==OP_BUY) Closer=MODE_BID;
   else return(-1);
   for(int i=1;i<=Requots;i++){
      Res=(OrderClose(Ticket,OrderLots(),MarketInfo(OrderSymbol(),Closer),Slippage));
      int Err=GetLastError();
      if(Res==true){
         if(UseSound==1) PlaySound(SND_Close);
         return(0);
         }
      if(Err==1) return(1);
      if(Err!=135) return(Err);
      }
   return(-2);
   }


