//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

void ReqOn(string Text="  ", string Text2="", string Text3="",int Break=0){
   Fncs++;
   
   Stat_Title[ST_INF1]=Text;
   Stat_Title[ST_INF2]=Text2;
   Stat_Title[ST_INF3]=Text3;
   RefStatics();
   ObjectDelete("_DesBalance");
   ObjectDelete("_InfBalance");
   ObjectDelete("_DesEquity");
   ObjectDelete("_InfEquity");
   ObjectDelete("_DesProfit");
   ObjectDelete("_InfProfit");
   ObjectDelete("_DesFreeMargin");
   ObjectDelete("_InfFreeMargin");
   ObjectDelete("_DesSpreadLevel");
   ObjectDelete("_InfSpreadLevel");
   Comment("_");
   if(IsTesting()==false) Sleep(Break);
   return;
   }

void Error(int IND){
   Fncs++;
   string Err="  "+DoubleToStr(IND,0);
   if(IND==130) Err="  !";
   //Alert(Err);
   }
int GetHour(string Var){
   Fncs++;
   int Res=StrToDouble(StringSubstr(Var,0,2));
   return(Res);
   }
int GetMin(string Var){
   Fncs++;
   int Res=StrToDouble(StringSubstr(Var,3,2));
   return(Res);
   }
int Sells(){
   Fncs++;
   int Res=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()) Res++;
      }
   return(Res);
   }
int Buys(){
   Fncs++;
   int Res=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()) Res++;
      }
   return(Res);
   }
int SellStops(){
   Fncs++;
   int Res=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol()) Res++;
      }
   return(Res);
   }
int BuyStops(){
   Fncs++;
   int Res=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol()) Res++;
      }
   return(Res);
   }
double StoimPunkt(string B){
   Fncs++;
   double S = MarketInfo(B,MODE_TICKVALUE)/(MarketInfo(B,MODE_TICKSIZE)/MarketInfo(B,MODE_POINT));
   return(S);
   }
void NewLine(int Type,double Price){
   Fncs++;
   
   for(int i=1;i<=LineLimit;i++){
      if(Type==1){
         if(Price>Ask){
            if(ObjectFind("__LineStop_UP"+DoubleToStr(i,0))==-1){
               ObjectCreate("__LineStop_UP"+DoubleToStr(i,0),OBJ_HLINE,0,0,0);
               ObjectSet("__LineStop_UP"+DoubleToStr(i,0),OBJPROP_PRICE1,Price);
               ObjectSet("__LineStop_UP"+DoubleToStr(i,0),OBJPROP_COLOR,CL_LineStop);
               ObjectSet("__LineStop_UP"+DoubleToStr(i,0),OBJPROP_WIDTH,1);
               ObjectSet("__LineStop_UP"+DoubleToStr(i,0),OBJPROP_STYLE,3);
               i=LineLimit+1;
               }
            }
         if(Price<Bid){
            if(ObjectFind("__LineStop_DN"+DoubleToStr(i,0))==-1){
               ObjectCreate("__LineStop_DN"+DoubleToStr(i,0),OBJ_HLINE,0,0,0);
               ObjectSet("__LineStop_DN"+DoubleToStr(i,0),OBJPROP_PRICE1,Price);
               ObjectSet("__LineStop_DN"+DoubleToStr(i,0),OBJPROP_COLOR,CL_LineStop);
               ObjectSet("__LineStop_DN"+DoubleToStr(i,0),OBJPROP_WIDTH,1);
               ObjectSet("__LineStop_DN"+DoubleToStr(i,0),OBJPROP_STYLE,3);
               i=LineLimit+1;
               }
            }
         }
      if(Type==2){
         if(Price>Ask){
            if(ObjectFind("__LineExit_UP"+DoubleToStr(i,0))==-1){
               ObjectCreate("__LineExit_UP"+DoubleToStr(i,0),OBJ_HLINE,0,0,0);
               ObjectSet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_PRICE1,Price);
               ObjectSet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_COLOR,CL_LineExit);
               ObjectSet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_WIDTH,1);
               ObjectSet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_STYLE,3);
               i=LineLimit+1;
               }
            }
         if(Price<Bid){
            if(ObjectFind("__LineExit_DN"+DoubleToStr(i,0))==-1){
               ObjectCreate("__LineExit_DN"+DoubleToStr(i,0),OBJ_HLINE,0,0,0);
               ObjectSet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_PRICE1,Price);
               ObjectSet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_COLOR,CL_LineExit);
               ObjectSet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_WIDTH,1);
               ObjectSet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_STYLE,3);
               i=LineLimit+1;
               }
            }
         }
      }
   if(UseSound==true) PlaySound(SND_Line);
   }
void DelLine(int Type){
   Fncs++;
   for(int i=1;i<=LineLimit;i++){
      if(Type==1){
         if(ObjectFind("__LineStop_UP"+DoubleToStr(i,0))!=-1){
            ObjectDelete("__LineStop_UP"+DoubleToStr(i,0));
            if(UseSound==true) PlaySound(SND_Line);
            if(IsTesting()==false) Sleep(300);
            Comment(" ");
            }
         if(ObjectFind("__LineStop_DN"+DoubleToStr(i,0))!=-1){
            ObjectDelete("__LineStop_DN"+DoubleToStr(i,0));
            if(UseSound==true) PlaySound(SND_Line);
            if(IsTesting()==false) Sleep(300);
            Comment(" ");
            }
         }
      if(Type==2){
         if(ObjectFind("__LineExit_UP"+DoubleToStr(i,0))!=-1){
            ObjectDelete("__LineExit_UP"+DoubleToStr(i,0));
            if(UseSound==true) PlaySound(SND_Line);
            if(IsTesting()==false) Sleep(300);
            Comment(" ");
            }
         if(ObjectFind("__LineExit_DN"+DoubleToStr(i,0))!=-1){
            ObjectDelete("__LineExit_DN"+DoubleToStr(i,0));
            if(UseSound==true) PlaySound(SND_Line);
            if(IsTesting()==false) Sleep(300);
            Comment(" ");
            }
         }
      }
   
   }

void ReadPresets(){
   Fncs++;
   if(ObjectFind("P_Lots")!=-1) Lots=StrToDouble(ObjectDescription("P_Lots"));
   if(ObjectFind("P_Risk")!=-1) Risk=StrToInteger(ObjectDescription("P_Risk"));
   if(ObjectFind("P_TP")!=-1) TakeProfit=StrToInteger(ObjectDescription("P_TP"));
   if(ObjectFind("P_SL")!=-1) StopLoss=StrToInteger(ObjectDescription("P_SL"));
   if(ObjectFind("P_Trall")!=-1) TrallingStop=StrToInteger(ObjectDescription("P_Trall"));
   if(ObjectFind("P_Step")!=-1) TrallingStep=StrToInteger(ObjectDescription("P_Step"));
   if(ObjectFind("P_PTrall")!=-1) PendTrallingStop=StrToInteger(ObjectDescription("P_PTrall"));
   if(ObjectFind("P_PStep")!=-1) PendTrallingStep=StrToInteger(ObjectDescription("P_PStep"));
   if(ObjectFind("P_XP")!=-1) XProfit=StrToInteger(ObjectDescription("P_XP"));
   
   if(ObjectFind("C_Sound")!=-1){
      //Alert(ObjectGet("P_Sound",OBJPROP_COLOR)," ",CL_FlagOn);
      if(ObjectGet("C_Sound",OBJPROP_COLOR)==CL_FlagOn) UseSound=true;
      if(ObjectGet("C_Sound",OBJPROP_COLOR)==CL_FlagOff) UseSound=false;
      }
   if(ObjectFind("C_Block")!=-1){
      if(ObjectGet("C_Block",OBJPROP_COLOR)==CL_FlagOn) UseBlock=true;
      if(ObjectGet("C_Block",OBJPROP_COLOR)==CL_FlagOff) UseBlock=false;
      }
   if(ObjectFind("C_Masks")!=-1){
      if(ObjectGet("C_Masks",OBJPROP_COLOR)==CL_FlagOn) UseMasks=true;
      if(ObjectGet("C_Masks",OBJPROP_COLOR)==CL_FlagOff) UseMasks=false;
      }
   if(ObjectFind("C_Rev1")!=-1){
      if(ObjectGet("C_Rev1",OBJPROP_COLOR)==CL_FlagOn) Reverse=true;
      if(ObjectGet("C_Rev1",OBJPROP_COLOR)==CL_FlagOff) Reverse=false;
      }
   if(ObjectFind("C_Rev2")!=-1){
      if(ObjectGet("C_Rev2",OBJPROP_COLOR)==CL_FlagOn) Reverse2=true;
      if(ObjectGet("C_Rev2",OBJPROP_COLOR)==CL_FlagOff) Reverse2=false;
      }
   if(ObjectFind("C_Conf")!=-1){
      if(ObjectGet("C_Conf",OBJPROP_COLOR)==CL_FlagOn) UseConfirm=true;
      if(ObjectGet("C_Conf",OBJPROP_COLOR)==CL_FlagOff) UseConfirm=false;
      }
   StrReadPresets();
   return;
   }
bool UserConf(string Text,string Cap){
   Fncs++;
   if(IsTesting()==true) return(true);
   if(UseConfirm==false) return(true);
   if(UseSound==true) PlaySound(SND_Confirm);
   if(MessageBox(Text,Cap,0x00000001)==1) return(true);
   return(false);
   }
bool CheckTimeCorrect(int Hours, int Mins){
   Fncs++;
   if(Period()>1440) return(false);
   
   if(Period()==1) return(true);
   if(Period()==5){
      if(Mins==0 || Mins==5 || Mins==10 || Mins==15 || Mins==20 || Mins==25 || Mins==30 || Mins==35 || Mins==40 || Mins==5 || Mins==5 || Mins==5)return(true);
      else return(false);
      }
   if(Period()==15){
      if(Mins==0 || Mins==15 || Mins==30 || Mins==45) return(true);
      else return(false);
      }
   if(Period()==30){
      if(Mins==0 || Mins==30) return(true);
      else return(false);
      }
   if(Period()==60){
      if(Mins==0) return(true);
      return(false);
      }
   if(Period()==240){
      if(Mins!=0) return(false);
      if(Hours==0 || Hours==4 || Hours==8 || Hours==12 || Hours==16 || Hours==20) return(true);
      else return(false);
      }
   if(Period()==1440){
      if(Hours==0 && Mins==0) return(true);
      else return(false);
      }
   return(false);
   }
bool IsBar(int Hours,int Mins,int Bar,bool IncWeek=0){
   Fncs++;
   if(CheckTimeCorrect(Hours,Mins)==false) return(false);
   if(IncWeek==0){
      if(
         Mins==TimeMinute(Time[Bar])&&
         Hours==TimeHour(Time[Bar])
         )return(true);
      else return(false);
      }
   else{
      if(
         Mins==TimeMinute(Time[Bar])&&
         Hours==TimeHour(Time[Bar])&&
         IncWeek==TimeDayOfWeek(Time[Bar])
         )return(true);
      else return(false);
      }
   }
double LowBuy(){
   double Res=-1;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         if(OrderOpenPrice()<Res || Res==-1) Res=OrderOpenPrice();
         }
      }
   return(Res);
   }
double HighSell(){
   double Res=-1;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         if(OrderOpenPrice()>Res || Res==-1) Res=OrderOpenPrice();
         }
      }
   return(Res);
   }
int SellsProfit(){
   int Res=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         RefreshRates();
         Res+=(OrderOpenPrice()-Ask)/Point;
         }
      }
   Res=Res/Sells();
   return(Res);
   }
int BuysProfit(){
   int Res=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         RefreshRates();
         Res+=(Bid-OrderOpenPrice())/Point;
         }
      }
   Res=Res/Buys();
   return(Res);
   }
void SetProfitToSells(double Price){
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         Reqs++;
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Price,0);
         }
      }
   return;
   }
void SetProfitToBuys(double Price){
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         Reqs++;
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),Price,0);
         }
      }
   return;
   }

//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                             http://evgeno.ru |
//+----------------------------------------------+

